Attribute VB_Name = "Shutdown"
' Obligatory Credit to Origional Author:
' I borrowed this module (shutdown.bas) and a few linues
' in the code on the dlgError form from the following:
' Author: Shane C. Hage
' Web Download From: Http://www.planet-source-code.com/vb
' Program Source Name: "API Functions - UPDATED"

Option Explicit
'-----CONSTANT DECLARATION-----
Public Const EWX_LogOff As Long = 0
Public Const EWX_SHUTDOWN As Long = 1
Public Const EWX_REBOOT As Long = 2
Public Const EWX_FORCE As Long = 4
Public Const EWX_POWEROFF As Long = 8
Public Const mlngWindows95 = 0
Public Const mlngWindowsNT = 1
'-----FUNCTION DECLARATION-----
Public Declare Function ExitWindowsEx Lib "user32" (ByVal dwOptions As Long, ByVal dwReserved As Long) As Long
Public Declare Function GetVersion Lib "kernel32" () As Long
Private Declare Function GetLastError Lib "kernel32" () As Long
Private Declare Function GetCurrentProcess Lib "kernel32" () As Long
Private Declare Function OpenProcessToken Lib "advapi32" (ByVal ProcessHandle As Long, ByVal DesiredAccess As Long, TokenHandle As Long) As Long
Private Declare Function LookupPrivilegeValue Lib "advapi32" Alias "LookupPrivilegeValueA" (ByVal lpSystemName As String, ByVal lpName As String, lpLuid As LUID) As Long
Private Declare Function AdjustTokenPrivileges Lib "advapi32" (ByVal TokenHandle As Long, ByVal DisableAllPrivileges As Long, NewState As TOKEN_PRIVILEGES, ByVal BufferLength As Long, PreviousState As TOKEN_PRIVILEGES, ReturnLength As Long) As Long
'-----TYPE DECLARATIONS-----
Private Type LUID
    UsedPart As Long
    IgnoredForNowHigh32BitPart As Long
End Type
Private Type LUID_AND_ATTRIBUTES
    TheLuid As LUID
    Attributes As Long
End Type
Private Type TOKEN_PRIVILEGES
    PrivilegeCount As Long
    TheLuid As LUID
    Attributes As Long
End Type
'-----MISC. DECLARATIONS-----
Public glngWhichWindows32 As Long
Private Declare Sub SetLastError Lib "kernel32" (ByVal dwErrCode As Long)

Public Sub AdjustToken()
    Const TOKEN_ADJUST_PRIVILEGES = &H20
    Const TOKEN_QUERY = &H8
    Const SE_PRIVILEGE_ENABLED = &H2
    Dim hdlProcessHandle As Long
    Dim hdlTokenHandle As Long
    Dim tmpLuid As LUID
    Dim tkp As TOKEN_PRIVILEGES
    Dim tkpNewButIgnored As TOKEN_PRIVILEGES
    Dim lBufferNeeded As Long
    SetLastError 0
    hdlProcessHandle = GetCurrentProcess()
    If GetLastError <> 0 Then
        MsgBox "GetCurrentProcess error==" & GetLastError
    End If
    OpenProcessToken hdlProcessHandle, _
        (TOKEN_ADJUST_PRIVILEGES Or TOKEN_QUERY), hdlTokenHandle
    If GetLastError <> 0 Then
        MsgBox "OpenProcessToken error==" & GetLastError
    End If
    LookupPrivilegeValue "", "SeShutdownPrivilege", tmpLuid
    If GetLastError <> 0 Then
        MsgBox "LookupPrivilegeValue error==" & GetLastError
    End If
    tkp.PrivilegeCount = 1
    tkp.TheLuid = tmpLuid
    tkp.Attributes = SE_PRIVILEGE_ENABLED
    AdjustTokenPrivileges hdlTokenHandle, False, tkp, Len(tkpNewButIgnored), tkpNewButIgnored, lBufferNeeded
    If GetLastError <> 0 Then
        MsgBox "AdjustTokenPrivileges error==" & GetLastError
    End If
End Sub
