VERSION 5.00
Begin VB.Form dlgError 
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "System Error"
   ClientHeight    =   1695
   ClientLeft      =   2760
   ClientTop       =   3750
   ClientWidth     =   4230
   ControlBox      =   0   'False
   Icon            =   "dlgError.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   1695
   ScaleWidth      =   4230
   ShowInTaskbar   =   0   'False
   StartUpPosition =   2  'CenterScreen
   Begin VB.CommandButton CancelButton 
      Caption         =   "CANCEL"
      Enabled         =   0   'False
      Height          =   375
      Left            =   2160
      TabIndex        =   1
      Top             =   1200
      Width           =   1335
   End
   Begin VB.CommandButton OKButton 
      Caption         =   "OK"
      Height          =   375
      Left            =   720
      TabIndex        =   0
      Top             =   1200
      Width           =   1335
   End
   Begin VB.Label lblMessage 
      Caption         =   $"dlgError.frx":030A
      Height          =   855
      Left            =   720
      TabIndex        =   2
      Top             =   120
      Width           =   3375
   End
   Begin VB.Image Image1 
      Height          =   480
      Left            =   120
      Picture         =   "dlgError.frx":0398
      Top             =   120
      Width           =   480
   End
End
Attribute VB_Name = "dlgError"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
' +--------------------------------------------------------------------+
' Program Name: Error
' File Name:    error.exe
' Program Type: Standard Executable
' Version:      1.0.0
' Purpose:      All it does is throw up a dialoge box with a fake
'               System error, and then requiring you to reboot.
'               Make sure you use this on someone who has a sense of
'               humor, because it does force a reboot.
' Comments:     The best way to use this is put it in the user's
'               system folder, set the RunOnce value in the registry
'               to the name and path of the program, and sit back
'               watch the fun...  there is no harm done with this
'               program.  The worst is the reboot.
'
' +--------------------------------------------------------------------+
' | Author:   Bradley Buskey                                           |
' | Email:    bbuskey@sturm.org                                        |
' | Website:  http://www.sturm.org                                     |
' +--------------------------------------------------------------------+

Option Explicit

' This section checks the Windows Version for either WinNT or Win9x
' It does recognise and work on Windows 98.  I have tested the
' executable on both platforms and it runs beautifully.  We have had a
' GREAT time with this one.  Great joke...

Private Sub Form_Load()
    ' Always DIM the varriables
    Dim lngVersion As Long
    
    ' Get the windows version.
    lngVersion = GetVersion()
    
    ' Set up the varriable for use when closing Windows.
    If ((lngVersion And &H80000000) = 0) Then
        glngWhichWindows32 = mlngWindowsNT
    Else
        glngWhichWindows32 = mlngWindows95
    End If
    
    ' This cool little line keeps the window from showing up in the
    ' task list of both Windows 9x and Windows NT.
    App.TaskVisible = False
End Sub

' This is the only function that actually has ANY user interaction.
' With the CANCEL button disabled, the only choice is to hit OK.  I
' am working on a way to keep it from showing up in the Task Manager
' under NT.

Private Sub OKButton_Click()
    'Always DIM the varriables.
    Dim Msg, Style, Ttl, ReturnValue
    
    'This sets up the message box properties
    Msg = "The hard disk was unable to reinitialize because exclusive access to the drive could not be obtained.  The hard drive will reinitialize the next time you restart the system."
    Style = vbOKOnly + vbCritical + vbDefaultButton2
    Ttl = "System Error"
        
    ' This creates the message box.
    MsgBox Msg, Style, Ttl
    
    ' Lets make sure we  know what OS we are dealing with.
    If glngWhichWindows32 = mlngWindowsNT Then AdjustToken
    If glngWhichWindows32 = mlngWindows95 Then AdjustToken
    
    ' Close down the computer, no questions (or responses for
    ' that matter) allowed.
    ExitWindowsEx EWX_REBOOT, 0
    Unload Me
End Sub
